/***************************************************************************
 *   Copyright (C) 2005 by Bjoern Erik Nilsen & Fredrik Berg Kjoelstad     *
 *   bjoern_erik_nilsen@hotmail.com & fredrikbk@hotmail.com                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "externalchangemonitor.h"

//#include <signal.h>
//#include <stdio.h>
// #include <semaphore.h>
#include <iostream>


//Thread function.
extern "C" void* startMonitor(void *arg)
{
	ExternalChangeMonitor *monitor = (ExternalChangeMonitor*)arg;
	monitor->monitorFiles();
	pthread_exit(0);
}

/**
 * @todo uniform most of the getenv("home") calls so that it is done once
 * and pasted around.
 */
ExternalChangeMonitor::ExternalChangeMonitor(AnimationModel *animationModel)
{
	this->animationModel = animationModel;
	
	this->tmpDirectory = getenv("HOME");
	this->tmpDirectory += "/.stopmotion/tmp";
	
	
//	this->isMonitoring = false;
	
	//changeWorkDirectory("test");
}


void ExternalChangeMonitor::changeWorkDirectory(const char* workDirectory)
{
	Logger::get().logDebug("Registring working directory for changelistening: ");
	Logger::get().logDebug(workDirectory);
	this->workDirectory = workDirectory;
	
	
	
	/*Logger::get().logDebug("Registring working directory for changelistening: ");
	Logger::get().logDebug(workDirectory);*/
	
	
	
	/*
	FAMConnection    famConn;
	FAMRequest       famRequest;
	FAMEvent         famEvent;
	
	//cout << workDirectory << endl;
	
	
	
	
	while( 1 ) {
		if( FAMNextEvent( &famConn, &famEvent ) < 0 ) {
			if( errno == EINTR ) {
				printf( "Interrupted\n" );
				break;
			}
			
			Logger::get().logWarning("Error retrieving next FAM event");
 			//printf( "Error retrieving next FAM event : %s\n", strerror(errno) );
			FAMClose( &famConn );
			//exit( -1 );
		}
		
		if( famEvent.code == FAMChanged ) {
			///@TODO: Register event upwards
			
			printf( "FAM indicates file %s has changed\n", famEvent.filename );
		}
		if( famEvent.code == FAMDeleted ) {
			///@TODO: Remove the connection to this file.
			
			printf( "FAM indicates file %s has been deleted\n", famEvent.filename );
		}
	}

*/
	
	//Notifies the model that the file has been changed.
	//animationModel->animationChanged(alteredFile);
}


void ExternalChangeMonitor::startMonitoring()
{
	/*if( FAMOpen(&famConn) < 0 ) {
		Logger::get().logWarning("Warning: Cannot connect to FAM");
		return;
	}
	
	if( FAMMonitorDirectory( &famConn, tmpDirectory.c_str(), &famRequest, NULL ) < 0 ) {
		Logger::get().logWarning("Warning: Cannot monitor file: ");
		Logger::get().logWarning("/home/fredrik/teste/famtestfile");
		FAMClose( &famConn );
		return;
	}
	
	pthread_create(&monitorThread, NULL, startMonitor, this);*/
}


void ExternalChangeMonitor::stopMonitoring()
{
	if( FAMClose( &famConn ) < 0 ) {
		Logger::get().logWarning("Warning: Cannot close FAM connection");
		//printf( "Cannot close FAM connection : %s\n", strerror(errno) );
		//exit( -1 );
	}
}


void ExternalChangeMonitor::monitorFiles()
{
	while( true ) {
		sleep(1);
// 		Logger::get().logDebug("Polling FAM for changes in the project directories");
		
		if( FAMNextEvent( &famConn, &famEvent ) < 0 ) {
			if( errno == EINTR ) {
				printf( "Interrupted\n" );
				break;
			}
			
			Logger::get().logWarning("Error retrieving next FAM event");
			FAMClose( &famConn );
			//exit( -1 );
			break;
		}
		
		if( famEvent.code == FAMChanged ) {
			///@TODO: Register event upwards
			printf( "FAM indicates file %s has changed\n", famEvent.filename );
			
			//animationModel->animationChanged(famEvent.filename);
		}
		
		if( famEvent.code == FAMDeleted ) {
			///@TODO: Remove the connection to this file.
			printf( "FAM indicates file %s has been deleted\n", famEvent.filename );
		}
	}
}
